﻿using System;
using System.Windows.Forms;

namespace SevenSegTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            OutputNumbers();
        }
        
        private UInt32 accumulator = 0;
        private UInt32 state = 0;

        private void OutputNumbers()
        {
            sevenSegmentArray1.Segments[3].CustomPattern = (int)((~accumulator >> 24) & 0xFF);
            sevenSegmentArray1.Segments[2].CustomPattern = (int)((~accumulator >> 16) & 0xFF);
            sevenSegmentArray1.Segments[1].CustomPattern = (int)((~accumulator >> 8) & 0xFF);
            sevenSegmentArray1.Segments[0].CustomPattern = (int)(~accumulator & 0xFF);
        }

        private void calcAccumulator(UInt32 val, bool btn0, bool btn1, bool btn2, bool btn3)
        {
            if (btn0 == true)
                accumulator = val;
            else if (btn1 == true)
                accumulator = val << 1;
            else if (btn2 == true)
                accumulator = (val << 1) + val;
            else if (btn3 == true)
                accumulator = (val << 2);
        }
        
        private void processButtons(bool btn0, bool btn1, bool btn2, bool btn3)
        {
            if (state == 0)
            {
                state = 2;
                if (btn0 == true)
                    accumulator = (UInt32)(646947 * 1);
                else if (btn1 == true)
                    accumulator = (UInt32)(646947 * 2);
                else if (btn2 == true)
                    accumulator = (UInt32)(646947 * 3);
                else if (btn3 == true)
                    accumulator = (UInt32)(646947 * 4);
            }
            else if (state == 2)
            {
                UInt32 a = accumulator + 787242;
                calcAccumulator(a, btn0, btn1, btn2, btn3);
                state = 4;
            }
            else if (state == 4)
            {
                UInt32 b = accumulator + 385656;
                calcAccumulator(b, btn0, btn1, btn2, btn3);
                state = 6;
            }
            else if (state == 6)
            {
                UInt32 c = accumulator + 151583;
                calcAccumulator(c, btn0, btn1, btn2, btn3);
                state = 8;
            }
            else if (state == 8)
            {
                UInt32 d = accumulator + 101591;
                calcAccumulator(d, btn0, btn1, btn2, btn3);
                state = 10;
            }
            else if (state == 10)
            {
                UInt32 e = accumulator + 118067;
                calcAccumulator(e, btn0, btn1, btn2, btn3);
                state = 12;
            }
            else if (state == 12)
            {
                UInt32 e = accumulator + 701881;
                calcAccumulator(e, btn0, btn1, btn2, btn3);
                state = 0;
            }

            OutputNumbers();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            processButtons(true, false, false, false);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            processButtons(false, true, false, false);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            processButtons(false, false, true, false);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            processButtons(false, false, false, true);
        }
    }
}
